function [s]=flowshop(E)
//
//===================================
// A PARTIR DE LA MATRICE E DES TEMPS
// DES TACHES (mach, piece) --> tache
// CONSTRUIT UN SYST. LIN. MAX PLUS s.
//===================================
//
//
[nmach,npiece]=size(E)
A=sparse(%zeros(nmach*npiece,nmach*npiece))
D=A, X0=sparse(%zeros(nmach*npiece,1))
B=sparse(%zeros(nmach*npiece,nmach+npiece))
C=sparse(%zeros(nmach+npiece,nmach*npiece))
l=0*ones(1,nmach); d=0*ones(1,npiece);
for i=1:npiece,
 for j=1:nmach,
  ij=i+(j-1)*npiece;
  if E(j,i)==%0 then 
    if l(j)<>0 then l(j)=l(j)+1, end ; 
    if d(i)<>0 then d(i)=d(i)+1, end ; 
   else  
    if l(j)<>0 then D(ij,ij-l(j))=E(j,i-l(j)), end ;
    if d(i)<>0 then D(ij,ij-d(i)*npiece)=E(j-d(i),i), end ;
    if d(i)==0 then B(ij,i)=%1,  end , d(i)=1;
    if l(j)==0 then B(ij,j+npiece)=%1, end , l(j)=1; 
    end;
  end ; 
  C(i,ij-(d(i)-1)*npiece)=E(nmach-d(i)+1,i); 
end ;
for j=1:nmach, 
C(j+npiece,j*npiece-l(j)+1)=E(j,npiece-l(j)+1), 
end ;
s=mpsyslin(A,B,C,D,X0);
//
//

//
function [g,T,N]=flowshop_graph(E,m,p,hh)
//
//===========================================
// A PARTIR DES  MATRICES
//   - E(mach, palette) -->temps de  tache
//   - m(mach) nbre de machines
//   - p(palette) nbre de palettes
// CONSTRUIT UN GRAPHE REPRESENTANT LE FLOWSHOP
// et construit la matrice des dates T
// et des compteurs N.
//===========================================
//
//
[nmach,npiece]=size(E)
EE=string(E); pp=string(p); mm=string(m);
nd=0; l=0*ones(1,nmach); d=0*ones(1,npiece);
h=[]; t=[]; ce=[]; e=#([]); x=[]; y=[]; kk=hh*nmach/npiece*1.3; N=%0; T=%0;
for i=1:npiece,
 for j=1:nmach, 
  if E(j,i)==%0 then 
    A(j,i)=0;
    if l(j)<>0 then l(j)=l(j)+1, end ; 
    if d(i)<>0 then d(i)=d(i)+1, end ; 
  else  
    nd=nd+1 ;
    A(j,i)=nd ; x(nd)=i*kk+kk; y(nd)=j*hh+hh; c(nd)=1;
    if l(j)<>0 then hc=A(j,i-l(j)), h=[h,hc], t=[t,nd], 
        e=[e,E(j,i-l(j))], ce=[ce,1], T(hc,nd)=E(j,i-l(j)), N(hc,nd)=%1, end ;
    if d(i)<>0 then hc=A(j-d(i),i), h=[h,hc], t=[t,nd], 
        e=[e,E(j-d(i),i)], ce=[ce,1], T(hc,nd)=E(j-d(i),i), N(hc,nd)=%1, end ;
    if d(i)==0 then 
     nd=nd+1; x(nd)=kk*i+kk*3/4  ; y(nd)=hh; c(nd)=11;
     h=[h,nd]; t=[t,A(j,i)]; e=[e,p(i)]; ce=[ce,11]; bp(i)=nd;
     N(nd,A(j,i))=p(i); T(nd,A(j,i))=%1;
//      s(nd)=2, 
    end ; 
    d(i)=1;
    if l(j)==0 then 
      nd=nd+1; x(nd)=kk  ; y(nd)=j*hh+hh*3/4 ; c(nd)=11;
       h=[h,nd]; t=[t,A(j,i)]; e=[e,m(j)]; ce=[ce,11]; bm(j)=nd;
       N(nd,A(j,i))=m(j); T(nd,A(j,i))=%1;
//      s(nd)=2, 
    end ; 
    l(j)=1; 
    end ;
 end ; 
//   s(A(nmach-d(i)+1,i))=1;
nd=nd+1; x(nd)=kk*i+kk*3/4  ; y(nd)=(nmach+1)*hh+hh ; c(nd)=13;
hc=A(nmach-d(i)+1,i);h=[h,hc]; t=[t,nd];
e=[e,E(nmach-d(i)+1,i)]; ce=[ce,1]; 
T(hc,nd)=E(nmach-d(i)+1,i);N(hc,nd)=%1; 
h=[h,nd]; t=[t,bp(i)]; e=[e,0]; ce=[ce,32];
T(nd,bp(i))=%1; N(nd,bp(i))=%1;
end ;
for j=1:nmach, 
// s(A(j,npiece-l(j)+1))=1;
nd=nd+1; x(nd)=kk*(npiece+1)+kk  ; y(nd)=j*hh+hh*3/4 ; c(nd)=13;
hc=A(j,npiece-l(j)+1); h=[h,hc]; t=[t,nd];
e=[e,E(j,npiece-l(j)+1)]; ce=[ce,1];
T(hc,nd)=E(j,npiece-l(j)+1); N(hc,nd)=%1;
h=[h,nd]; t=[t,bm(j)]; e=[e,0]; ce=[ce,32];
T(nd,bm(j))=%1; N(nd,bm(j))=%1;
end ;
g=make_graph('flowshop',1,nd,h,t);
g('node_x')=x';
g('node_y')=y';
g('node_color')=c';
g('edge_color')=ce;
//g('edge_label')=e;
g('edge_length')=plustimes(e);
g('edge_name')=string([1:edge_number(g)]);
//g('node_type')=s';
show_graph(g);
T=sparse(T'); N=sparse(N');
//
//==============================================
// CONSTRUCTION DE T (temps) et N (nb de jetons)
// A PARTIR D'UN GRAPHE DE FLOWSHOP
//============================================
//
//function [T]=ticks(g)
//e=find(g('edge_color')==1);
//ep=find(g('edge_color')==10);
//e=[e,ep];
//i=g('tail')(e); j=g('head')(e);
//t=evstr(g('edge_label')(e));
//no=g('node_number');
//T=sparse([i',j'],t',[no,no])
//T=#(sparse([],[],[no,no]))
//T(no,no)=%0;
//T(i+(j-1)*no)=t
//
//function [N]=tokens(g)
//e=find(g('edge_color')==11);
//i=g('tail')(e); j=g('head')(e);
//n=evstr(g('edge_label')(e));
//no=g('node_number');
//N=#(sparse([i',j'],n',[no,no]))
//N=#(sparse([],[],[no,no]))
//N(no,no)=%0;
//N(i+(j-1)*no)=n;
//
function [TN]=tiplusto(g,l,m)
no=g('node_number');TN=full(%zeros(no,no));
e=find(g('edge_color')==11);
i=g('tail')(e); j=g('head')(e);
n=g('edge_length')(e);
TN(i+(j-1)*no)=-n.*l(j);
e=find(g('edge_color')==1);
i=g('tail')(e); j=g('head')(e);
t=g('edge_length')(e);
TN(i+(j-1)*no)=t.*m(j);
e=find(g('edge_color')==32);
i=g('tail')(e); j=g('head')(e);
t=g('edge_length')(e);
TN(i+(j-1)*no)=t.*m(j);
//
function [T]=ticks(g)
no1=ones(1,g('node_number')); no0=no1*0;
T=tiplusto(g,no0,no1);
//
function [N]=tokens(g)
no1=ones(1,g('node_number')); no0=no1*0;
N=tiplusto(g,-no1,no0);
//
//==============================t
//CAlCUL DU GRAPHE DE SATURATION
//==============================
//
//function [sg]=saturation_graph(g,T,N)
//[chi,v,n1,n2]=semihoward(T,N);
//an=#(plustimes(full(T))+plustimes(full(#(-plustimes(N)*diag(plustimes(chi))))));
//a=diag(v)\an*diag(v);
//[ir,ic]=find(a>#(-0.001));
//sg=subgraph(edge_nb(g,ir,ic)','edges',g);
//show_graph(sg)
//
function [sg]=Lsaturation_graph(g)
no1=ones(1,g('node_number'));
T=ticks(g); N=tokens(g);
[chi,v,p,n1,n2]=semihoward(T,N);
an=tiplusto(g,plustimes(chi)',no1)
a=diag(v)\an*diag(v);
[ir,ic]=find(a>#(-0.000001));
sg=subgraph(edge_nb(g,ir,ic)','edges',g);

function [sg]=Rsaturation_graph(g)
no1=ones(1,g('node_number'));
T=ticks(g); N=tokens(g);
[chi,v,p,n1,n2]=semihoward(T',N');
an=tiplusto(g,plustimes(chi)',no1)
a=diag(v)*an/diag(v);
[ir,ic]=find(a>#(-0.000001));
sg=subgraph(edge_nb(g,ir,ic)','edges',g);


//show_graph(sg)
//
//==========================================
// CALCUL DU  GRAPHE CRITIQUE
//==========================================
//
//function [edn,gh]=critical_graph(g,sg);
//[nc,ncomp]=strong_connex(sg);
//en=find(ncomp(sg('head'))==ncomp(sg('tail')));
//ng=evstr(sg('node_name'));
//t=ng(sg('tail')(en));
//h=ng(sg('head')(en));
//edn=edge_nb(g,t',h');
//w=ones(1,edge_number(g));
//w(edn')=4;
//gh=g;
//gh('edge_width')=w;
//show_graph(gh)
//
//
function [edn,gh]=critical_graph(g,sg)
[nc,ncomp]=strong_connex(sg);
en=find(ncomp(sg('head'))==ncomp(sg('tail')));
ng=evstr(sg('edge_name'));
edn=ng(en);
w=ones(1,edge_number(g));
w(edn)=4;
gh=g;
gh('edge_width')=w;
show_graph(gh);
//
//function [sc]=critical_graph(sg)
//[nc,ncomp]=strong_connex(sg)
//dc=sort(ncomp)
//ncp=dc(find((dc(2:$)-dc(1:$-1))==0))
//ndstg=find(ncomp==ncp(1))
//sc=subgraph(ndstg,'nodes',sg)
//show_graph(sc)
//
//
//
//=============================
// HILITE LA 1ere CMP CRITIQUE
//=============================
//
//function [edn,gh]=hilite(g,sc)
//ng=evstr(sc('node_name'))
//t=ng(sc('tail'))
//h=ng(sc('head'))
//edn=edge_nb(g,t',h')
////g('edge_color')(edn')=11
//w=ones(1,edge_number(g))
//w(edn')=4
//gh=g
//gh('edge_width')=w
//show_graph(gh)
////show_arcs(edn','sup')
//
function [gh]=show_cr_graph(g)
[edn,gh]=critical_graph(g,Lsaturation_graph(g))
//
//====================================
// DONNE LE NUMERO DES ARCS DE g
// INDEXES PAR LES NOEUDS DE DEPART tail
// ET PAR LES NOEUDS D'ARRIVEE head
//====================================
//
function [ed]=edge_nb(g,tail,head)
gh=g('head');
ne=sparse([g('tail')',gh'],[1:size(gh,2)]');
ed=full(ne(tail+(head-1)*g('node_number')));
// 
//============================================
//CONSTRUIT LE GRAPHE DES COMPOSANTES CONNEXES
//============================================
//
function [gc]=strong_connex_graph(g)
[nc,ncomp]=strong_connex(g);
en=find(ncomp(g('head'))==ncomp(g('tail')));
gc=g;
gc('tail')=g('tail')(en);
gc('head')=g('head')(en);
gc('edge_name')=g('edge_name')(en);
gc('edge_color')=g('edge_color')(en);
gc('edge_length')=g('edge_length')(en);
//
//=================================================================
//COPIE DE LA PARTIE CONSACREE AUX NOEUDS DE LA GRAPH-LIST G DANS GC
//=================================================================
//
function [gc]=copy_nodes_struct(g,gc)
l=list('node_number','node_name','node_type','node_x','node_y','node_color',..
    'node_diam','node_font_size','node_demand')
for i=l, gc(i)=g(i), end
//
//=======================
//  FLOWSHOP SIMULATION
//=======================
//
function [chi,y]=flowshop_simu(s,nm,np,u)
nmach=size(nm,2); npiece=size(np,2); nt=size(u,2); 
fbm=shift(nm(1),0) ;
for i=1:nmach-1, fbm=fbm|shift(nm(i),0) ; end ;
fbp=shift(np(1),0);
for i=1:npiece-1, fbp=fbp|shift(np(i),0) ; end ;
sb=s/.(fbp|fbm);
sbs=explicit(sb);
chi=howard(sbs('A'));
y=simul(sbs,u);
chit=plustimes(chi(1))*[1:nt];
y=plustimes(y)-ones(nmach+npiece,1)*chit;
//plot2d(y(:,[1:nt])');
