.TH astarb  " " " " "Maxplus Function"
.SH NAME
astarb -  maxplus linear system solution
.SH CALLING SEQUENCE
.nf
w=astarb(A,b)
.fi
.SH PARAMETERS
.TP 10
A
: maxplus full or sparse  square matrix
.TP 10
b
: maxplus full or sparse vector
.TP 10
w
: (Id+A+A^2+.....)*b
.SH DESCRIPTION
Solve \fVx=Ax+b\fR in the maxplus algebra
when there is no circuits with positive weight in
G(A') (the incidence graph of A', that is it exists an arc from j to i 
if A_ij is nonzero).

It is much more efficient in time and memory than star(A)*b.
.SH EXAMPLES
.nf
A=#([-3,-2;-1,0]) 
b=[%0;%1]
w=astarb(A,b)
n=10;A=#(-rand(n,n));b=#(rand(n,1));astarb(A,b)-star(A)*b
.fi
.SH SEE ALSO
star,
karp,
howard,
semihoward,
maxplus,
shortest_path 




